// vim: et:ts=4:sw=4:sts=4:ft=javascript

/*@
Ox.App <f> Basic application instance that communicates with a JSON API
    () ->              <f> App object
    (options) ->       <f> App object
    options <o> Options object
        timeout <n> request timeout
        type    <s> HTTP Request type, i.e. 'GET' or 'POST'
        url     <s> JSON API url
    self <o>    Shared private variable
    load <!>    app loaded
@*/

Ox.App = function(options) {

    var self = {
            options: Ox.extend({
                timeout: 60000,
                type: 'POST',
                url: '/api/',
            }, options || {}),
            time: new Date()
        },
        that = Ox.Element({}, Ox.extend({}, self));

    that.api = {
        api: function(callback) {
            Ox.Request.send({
                url: self.options.url,
                data: {
                    action: 'api'
                },
                callback: callback
            });
        },
        cancel: function(id) {
            Ox.Request.cancel(id);
        }
    };

    $.ajaxSetup({
        timeout: self.options.timeout,
        type: self.options.type,
        url: self.options.url
    });

    /*@
    api <o> bakcend API
        [action] <f> all api requests available on backend
        cancel   <f> cancel a request
        options  <f> get or set options
    @*/
    that.api.api(function(result) {
        Ox.forEach(result.data.actions, function(val, key) {
            that.api[key] = function(/*data, age, callback*/) {
                var data = {}, age = -1, callback = null;
                Ox.forEach(arguments, function(argument) {
                    if (Ox.isObject(argument)) {
                        data = argument;
                    } else if (Ox.isNumber(argument)) {
                        age = argument;
                    } else if (Ox.isFunction(argument)) {
                        callback = argument;
                    }
                });
                return Ox.Request.send(Ox.extend({
                    age: age,
                    callback: callback,
                    data: {
                        action: key,
                        data: JSON.stringify(data)
                    },
                    url: self.options.url
                }, !val.cache ? {age: 0}: {}));
            };
        });
        that.api.init(getUserData(), function(result) {
            //Ox.UI.hideLoadingScreen();
            that.triggerEvent({
                load: result.data
            });
        });
    });

    function getUserData() {
        return {
            document: {
                referrer: document.referrer
            },
            history: {
                length: history.length
            },
            navigator: {
                cookieEnabled: navigator.cookieEnabled,
                plugins: Ox.makeArray(navigator.plugins).map(function(plugin) {
                    return plugin.name;
                }),
                userAgent: navigator.userAgent
            },
            screen: screen,
            time: (+new Date() - self.time) / 1000,
            window: {
                innerHeight: window.innerHeight,
                innerWidth: window.innerWidth,
                outerHeight: window.outerHeight,
                outerWidth: window.outerWidth,
                screenLeft: window.screenLeft,
                screenTop: window.screenTop
            }
        };
    }

    /*@
    change <f> change key/value
        (key, value) -> <u> currently not implemented
    @*/
    self.setOption = function(key, value) {
        
    };

    /*@
    options <f> get/set options, see Ox.getset
        () -> <o> get options
        (options) -> <o> update/set options
    @*/
    that.options = function() {
        return Ox.getset(self.options, Array.prototype.slice.call(arguments), self.change, that);
    };

    return that;

};
